clang-tools 6.0.0

Public Member Functions | List of all members
clang::tidy::bugprone::MoveForwardingReferenceCheck Class Reference

The check warns if std::move is applied to a forwarding reference (i.e. More...

`#include <MoveForwardingReferenceCheck.h>`

Inheritance diagram for clang::tidy::bugprone::MoveForwardingReferenceCheck:
[legend]
Collaboration diagram for clang::tidy::bugprone::MoveForwardingReferenceCheck:
[legend]

## Public Member Functions
| MoveForwardingReferenceCheck (StringRef Name, ClangTidyContext *Context)
void | registerMatchers (ast_matchers::MatchFinder *Finder) override
| Override this to register AST matchers with `Finder`. More...
void | check (const ast_matchers::MatchFinder::MatchResult &Result) override
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
virtual void | registerPPCallbacks (CompilerInstance &Compiler)
| Override this to register `PPCallbacks` with `Compiler`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...
virtual void | storeOptions (ClangTidyOptions::OptionMap &Options)
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
LangOptions | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

The check warns if std::move is applied to a forwarding reference (i.e.

an rvalue reference of a function template argument type).

If a developer is unaware of the special rules for template argument deduction on forwarding references, it will seem reasonable to apply std::move to the forwarding reference, in the same way that this would be done for a "normal" rvalue reference.

This has a consequence that is usually unwanted and possibly surprising: if the function that takes the forwarding reference as its parameter is called with an lvalue, that lvalue will be moved from (and hence placed into an indeterminate state) even though no std::move was applied to the lvalue at the call site. The check suggests replacing the std::move with a std::forward.

For the user-facing documentation see: http://clang.llvm.org/extra/clang-tidy/checks/bugprone-move-forwarding-reference.html

Definition at line 37 of file MoveForwardingReferenceCheck.h.

## Constructor & Destructor Documentation

## ◆ MoveForwardingReferenceCheck()

clang::tidy::bugprone::MoveForwardingReferenceCheck::MoveForwardingReferenceCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |
| inline

Definition at line 39 of file MoveForwardingReferenceCheck.h.

References registerMatchers().

## Member Function Documentation

## ◆ check()

void clang::tidy::bugprone::MoveForwardingReferenceCheck::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| override virtual

`ClangTidyChecks` that register ASTMatchers should do the actual work in here.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 96 of file MoveForwardingReferenceCheck.cpp.

References clang::tidy::bugprone::replaceMoveWithForward().

## ◆ registerMatchers()

void clang::tidy::bugprone::MoveForwardingReferenceCheck::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| override virtual

Override this to register AST matchers with `Finder`.

This should be used by clang-tidy checks that analyze code properties that dependent on AST knowledge.

You can register as many matchers as necessary with `Finder`. Usually, "this" will be used as callback, but you can also specify other callback classes. Thereby, different matchers can trigger different callbacks.

If you need to merge information between the different matchers, you can store these as members of the derived class. However, note that all matches occur in the order of the AST traversal.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 70 of file MoveForwardingReferenceCheck.cpp.

Referenced by MoveForwardingReferenceCheck().

The documentation for this class was generated from the following files:

- MoveForwardingReferenceCheck.h
- MoveForwardingReferenceCheck.cpp